/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.AnagClientRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class AnagClient extends TableImpl<AnagClientRecord> {

    private static final long serialVersionUID = 1792701038;

    /**
     * The reference instance of <code>ANAG_CLIENT</code>
     */
    public static final AnagClient ANAG_CLIENT = new AnagClient();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<AnagClientRecord> getRecordType() {
        return AnagClientRecord.class;
    }

    /**
     * The column <code>ANAG_CLIENT.ID_ANAG_CLIENT</code>.
     */
    public final TableField<AnagClientRecord, Integer> ID_ANAG_CLIENT = createField("ID_ANAG_CLIENT", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>ANAG_CLIENT.CODE</code>.
     */
    public final TableField<AnagClientRecord, String> CODE = createField("CODE", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>ANAG_CLIENT.COMPANY_NAME</code>.
     */
    public final TableField<AnagClientRecord, String> COMPANY_NAME = createField("COMPANY_NAME", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>ANAG_CLIENT.COUNTRY</code>.
     */
    public final TableField<AnagClientRecord, String> COUNTRY = createField("COUNTRY", org.jooq.impl.SQLDataType.VARCHAR(3), this, "");

    /**
     * The column <code>ANAG_CLIENT.VAT_CODE</code>.
     */
    public final TableField<AnagClientRecord, String> VAT_CODE = createField("VAT_CODE", org.jooq.impl.SQLDataType.VARCHAR(45), this, "");

    /**
     * The column <code>ANAG_CLIENT.VAT_DESCRIPTION</code>.
     */
    public final TableField<AnagClientRecord, String> VAT_DESCRIPTION = createField("VAT_DESCRIPTION", org.jooq.impl.SQLDataType.CLOB, this, "");

    /**
     * The column <code>ANAG_CLIENT.FOREIGN_CLIENT</code>.
     */
    public final TableField<AnagClientRecord, Byte> FOREIGN_CLIENT = createField("FOREIGN_CLIENT", org.jooq.impl.SQLDataType.TINYINT.nullable(false), this, "");

    /**
     * Create a <code>ANAG_CLIENT</code> table reference
     */
    public AnagClient() {
        this(DSL.name("ANAG_CLIENT"), null);
    }

    /**
     * Create an aliased <code>ANAG_CLIENT</code> table reference
     */
    public AnagClient(String alias) {
        this(DSL.name(alias), ANAG_CLIENT);
    }

    /**
     * Create an aliased <code>ANAG_CLIENT</code> table reference
     */
    public AnagClient(Name alias) {
        this(alias, ANAG_CLIENT);
    }

    private AnagClient(Name alias, Table<AnagClientRecord> aliased) {
        this(alias, aliased, null);
    }

    private AnagClient(Name alias, Table<AnagClientRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> AnagClient(Table<O> child, ForeignKey<O, AnagClientRecord> key) {
        super(child, key, ANAG_CLIENT);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ANAG_CLIENT_FK_COUNTRY_ANAG_CLIENT_IDX, Indexes.ANAG_CLIENT_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<AnagClientRecord, Integer> getIdentity() {
        return Keys.IDENTITY_ANAG_CLIENT;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<AnagClientRecord> getPrimaryKey() {
        return Keys.KEY_ANAG_CLIENT_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<AnagClientRecord>> getKeys() {
        return Arrays.<UniqueKey<AnagClientRecord>>asList(Keys.KEY_ANAG_CLIENT_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public AnagClient as(String alias) {
        return new AnagClient(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public AnagClient as(Name alias) {
        return new AnagClient(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public AnagClient rename(String name) {
        return new AnagClient(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public AnagClient rename(Name name) {
        return new AnagClient(name, null);
    }
}
